#define M 7
#define N 15

chan buffer = [8] of { mtype, byte };

mtype { print, dontprint, end };

byte counter = 0;

proctype producer()
{
  do
  :: (counter < M) ->                 buffer!dontprint,counter;
  :: (M <= counter && counter < N) -> buffer!print,counter;
  :: (counter >= N) ->                break;
  :: counter ++;
  od;

  buffer!end,counter;
}

proctype consumer()
{
  byte rec;

  do
  :: buffer?print,rec ->     printf( "Printing %d\n", rec );
  :: buffer?dontprint,rec -> skip;
  :: buffer?end,rec ->       printf( "Ending at %d\n", rec ); break;
  od
}

init { run producer(); run consumer() }
