/*
 * Author: Roberto Bruttomesso <roberto.bruttomesso@unisi.ch>
 *
 * Implementation of a buggy interaction
 */

byte printer = 0, scanner = 0; // both resources are available

proctype proc_A()
{
  printer == 0;  // busy waiting: while( printer != 0 );
  printer = 1;   // acquire resource printer
  scanner == 0;  // busy waiting: while( scanner != 0 );
  scanner = 1;   // acquire resource scanner

  //
  // Do something with printer and scanner
  //

  scanner = 0;   // release resource scanner
  printer = 0;   // release resource printer

  printf( "Process A done !\n" );
}

proctype proc_B()
{
  scanner == 0;  // busy waiting: while( scanner != 0 );
  scanner = 1;   // acquire resource scanner
  printer == 0;  // busy waiting: while( printer != 0 );
  printer = 1;   // acquire resource printer

  //
  // Do something with printer and scanner
  //

  printer = 0;   // release resource printer
  scanner = 0;   // release resource scanner

  printf( "Process B done !\n" );
}


init { run proc_A(); run proc_B() }
