#define p     0
#define v     1
#define N     3

chan sema = [0] of { bit };
byte nr_users_in_section = 0;
bool flags[N];

proctype dijkstra( )
{
  byte count = 1;

  do
     :: (count == 1) ->
         sema!p;
         count = 0;
     :: (count == 0) ->
         sema?v;
         count = 1;
  od
}

proctype user( byte n )
{
  flags[n] = false; 

  do
  :: sema?p ->
  
      nr_users_in_section ++;
      flags[n] = true;
      
      printf( "User%d: critical section\n", n );

      nr_users_in_section --;
      flags[n] = false;
      
      sema!v;
  od
}

init
{
  run dijkstra();

  byte n = 0;
  do
    :: (n == N) -> break;
    :: else -> run user(n); n++;
  od
}
